=== debian/changelog ===
codelite (17.0.0+dfsg-6) unstable; urgency=medium

  * QA upload.
  * Backport upstream fix and add -DCMAKE_POLICY_VERSION_MINIMUM=3.5
    for supporting CMake 4. (Closes: #1112801)

 -- Adrian Bunk <bunk@debian.org>  Sat, 18 Oct 2025 20:36:05 +0300
