=== debian/control ===
Source: codelite
Section: devel
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake (>= 3.16),
 libclang-dev [amd64 arm64 armel armhf i386 mips64el mipsel ppc64 ppc64el riscv64 s390x],
 libgtk-3-dev,
 libhunspell-dev,
 liblldb-dev [amd64 arm64 armel armhf i386 ppc64el s390x],
 libssh-dev,
 libwxgtk3.2-dev,
 libwxsqlite3-3.2-dev,
 llvm [amd64 arm64 armel armhf i386 mips64el mipsel ppc64 ppc64el riscv64 s390x],
 libwebsocketpp-dev,
 libasio-dev,
 pkg-config
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://codelite.org
Vcs-Git: https://salsa.debian.org/debian/codelite.git
Vcs-Browser: https://salsa.debian.org/debian/codelite

Package: codelite
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends:
 gdb,
 wx-common,
 gcc,
 g++,
 xterm | x-terminal-emulator
Suggests: codelite-plugins, python3
Description: Powerful and lightweight IDE
 CodeLite is a powerful and lightweight IDE specializing in C, C++, PHP and
 Javascript. Its features include:
  * Generic support for compilers
  * Built-in GDB support
  * Database-based Code Completion mechanism
  * Syntax highlighting for C/C++, Java, Perl, XML, Makefile, Lua, Diff files,
    PHP, JavaScript, Python, HTML, and ASP
  * Text Folding
  * Bookmarks
  * Find and Replace
  * doxygen comment generator

Package: codelite-plugins
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 codelite (= ${binary:Version})
Recommends:
 clangd,
 clang-format,
 cppcheck,
 libunittest++-dev,
 nodejs,
 qt5-qmake,
 valgrind,
 libasio-dev,
 universal-ctags,
Description: Powerful and lightweight IDE - plugins
 CodeLite is a powerful and lightweight IDE specializing in C, C++, PHP and
 Javascript. Its features include:
  * Generic support for compilers
  * Built-in GDB support
  * Database-based Code Completion mechanism
  * Syntax highlighting for C/C++, Java, Perl, XML, Makefile, Lua, Diff files,
    PHP, JavaScript, Python, HTML, and ASP
  * Text Folding
  * Bookmarks
  * Find and Replace
  * doxygen comment generator
 .
 This package contains the plugins for CodeLite, including its
 form-designer wxCrafter.
