=== debian/watch ===
version=4
opts=dversionmangle=s/\+dfsg\d?$//,\
uversionmangle=s/-/./,oversionmangle=s/$/+dfsg/ \
https://www.4pane.co.uk/codelite-(.*)\.tar\.gz
